/// <reference types="node" />
import { Worker, WorkerOptions } from 'node:worker_threads';
import ThreadManager from './threadManager';
export default class Thread {
    readonly name: string;
    readonly filename: string;
    readonly options?: WorkerOptions;
    threadManager: ThreadManager;
    protected worker: Worker;
    constructor(threadManager: ThreadManager, name: string, filename: string, options?: WorkerOptions);
    emit(messageKey: string, ...value: unknown[]): void;
    on(event: 'online', cb: (...value: unknown[]) => unknown): void;
    on(event: 'exit', cb: (...value: unknown[]) => unknown): void;
    on(event: 'messageError', cb: (...value: unknown[]) => unknown): void;
    on(messageKey: string, cb: (...value: unknown[]) => unknown): void;
    close(exit?: number): void;
}
