import ThreadManagerClass from './core/threadManager';
import ThreadClass from './core/thread';
import ThreadSelfClass from './core/threadSelf';
declare namespace NeedleJS {
    const ThreadManager: typeof ThreadManagerClass;
    const Thread: typeof ThreadClass;
    const ThreadSelf: typeof ThreadSelfClass;
    namespace Types {
        enum BuiltInMessageKeys {
            Shutdown = "NEEDLEJS-THREAD-SHUTDOWN"
        }
        enum ThreadReservedMessageKeys {
            'online' = 0,
            'exit' = 1,
            'messageError' = 2
        }
        enum ThreadSelfReservedMessageKeys {
            'close' = 0,
            'messageError' = 1
        }
        interface MessageFormat {
            messageKey: string;
            value: unknown[];
        }
    }
}
export default NeedleJS;
